#!/usr/bin/perl
#
# $NewGold: cvstat.pl,v 1.13 2002/01/15 06:46:37 jmallett Exp $
#
# CVS Statistics Generator for the World Wide Web.
#
# Written by J. Mallett.
# This file is in the public domain and the author may not be liable for
# any damage caused by this software directly or indirectly.
#
# NOTES
# 	In this version, "Change" is used instead of "Commit" as an individual
# 	commit (as per the 'cvs commit' command) may be responsible for several
# 	changes, and grouping them isn't possible AFAIK. So this is more accurate.

require './util/cvstat.conf';

print <<EOF;
<html>
 <head>
  <title>$server CVS statistics</title>
 </head>
 <body bgcolor="$background">
  <font color="$foreground" face="$font">
   <table>
    <tr bgcolor="$background">
     <td align="center">
      <strong>$server CVS statistics</strong>
     </td>
    </tr>
    <tr>
     <td>
      <table bgcolor="$border" border="0" cellspacing="1" cellpadding="2" width="100\%">
       <tr bgcolor="$heading">
        <td>Committer</td>
         <td>\# of Changes</td>
         <td>Lines Changed</td>
         <td>Lines per Change</td>
         <td>\% of Changed Lines</td>
        </tr>
EOF

$global = 0;		# Global total number of added lines
$highnum = 0;		# High number of revisions
$highfile = "";		# Highest revised file
$highcommits = 0;	# High number of commits per a committer
$highcommitter = "";	# Highest revising committer

$currentisbinary = 0;	# Is the current file a binary? Its +x-y are bogus
$skipfile = 0;		# Is this a file we want to omit?

open(DATA, "<$cvslog") || die "$!";
while (<DATA>) {
    while (!/^RCS file:/ && $skipfile) {
        $_ = <DATA>;
    }
    if (/^date: /) {
        $author = "$_";
        $author =~ s/date: .* author: (.*) state: .*/$1/i;
        $author =~ s/\;//g;
        if ($lines{"$author"} !~ /./) {
            $lines{"$author"} = 0;
        }
        if ($commits{"$author"} !~ /./) {
            $commits{"$author"} = 0;
        }
        $commits{"$author"} ++;
        if (/lines:/ && !$currentisbinary) {
            $changes = "$_";
            $changes =~ s/.*lines: \+([0-9]*) \-([0-9]*)/$1+$2/;
            $abschange = eval "$changes";
            $lines{"$author"} += $abschange;
            $global += $abschange;
        }
    }
    if (/^RCS file:/) {
        if ($files{"$curfile"} > $highnum) {
            $highnum = $files{"$curfile"};
            $highfile = "$curfile";
        }
        $curfile = "$_";
        $curfile =~ s/RCS file: //;
        $files{"$curfile"} = 0;
        $skipfile = 0;
        for (@ignorefiles) {
            if ($curfile =~ /$_/) {
                $skipfile = 1;
            }
        }
        $currentisbinary = 0;
    }
    if (/^revision/) {
        $files{"$curfile"} ++;
    }
    if (/^keyword substitution: b/) {
        $currentisbinary = 1;
    }
}
close(DATA);

$count = 0;

foreach $committer (sort keys %commits) {
    $number = $commits{"$committer"};
    $changes = $lines{"$committer"};
    if (($number > $minlines) && ($changes > $minchanges)) {
        $percent = ($changes / $global) * 100;
        $average = $changes / $number;
        foreach $_ ($percent, $average) {
            $_ += .5;
            s/\..*//g;
        }
        if ($number > $highcommits) {
            $highcommits = $number;
            $highcommitter = "$committer";
        }
        if ((($count++) % 2) && ($rowcolor2 =~ /./)) {
            print <<EOF;
      <tr bgcolor="$rowcolor2">
EOF
        } else {
            print <<EOF;
      <tr bgcolor="$rowcolor1">
EOF
        }
        print <<EOF;
       <td>$committer</td>
       <td>$number</td>
       <td>$changes</td>
       <td>$average</td>
       <td>$percent\%</td>
      </tr>
EOF
    }
}

print <<EOF;
      </table>
      <table bgcolor="$border" cellspacing="1" cellpadding="2" width="100\%">
       <tr>
        <td bgcolor="$heading">
         Total committers:
        </td>
        <td align="right" bgcolor="$rowcolor1">
         $count
        </td>
       </tr>
       <tr>
        <td bgcolor="$heading">
         Most frequently modified file:
        </td>
        <td align="right" bgcolor="$rowcolor1">
         $highfile (<em>$highnum</em>)
        </td>
       </tr>
       <tr>
       <td bgcolor="$heading">
         Most frequent committer:
        </td>
        <td align="right" bgcolor="$rowcolor1">
         $highcommitter (<em>$highcommits</em>)
        </td>
       </tr>
      </table>
     </td>
    </tr>
    <tr bgcolor="$background">
     <td align="center">
      <strong>$server CVS statistics generated by <b>cvstat</b></strong>
      <br>
      Created by <a href="http://people.FreeBSD.org/~jmallett/">J. Mallett</a>
     </td>
    </tr>
   </table>
  </font>
 </body>
</html>
<!-- cvstat 2.0 -->
EOF
